#!/usr/bin/env python

from os import system, getlogin
import os.path, os
import shutil

INSTALL_DIR = "/usr/local/bin"
DOC_DIR = "/usr/local/doc/microcsound"
SHARE_DIR = "/usr/local/share/microcsound"
PROGRAM = "microcsound.py"
PROGRAM_BASENAME = "microcsound"

def install_script():
    # documentation
    print "installing documentation..."
    try:
        os.makedirs(DOC_DIR)
    except OSError:
        pass
    shutil.copy2("README", DOC_DIR)
    shutil.copy2("CHANGES", DOC_DIR)
    shutil.copy2("microcsound_docs.html", DOC_DIR)

    # executable
    print "installing executeable..."
    os.chmod(PROGRAM, 0755)
    try:
        os.remove("%s/%s" % (INSTALL_DIR, PROGRAM_BASENAME))
        os.remove("%s/%s" % (INSTALL_DIR, PROGRAM))
    except:
        pass
    shutil.copy2(PROGRAM, INSTALL_DIR)
    os.symlink("%s/%s" % (INSTALL_DIR, PROGRAM), 
               "%s/%s" % (INSTALL_DIR, PROGRAM_BASENAME))

    # share files:
    print "installing dependency files..."
    try:
        os.makedirs(SHARE_DIR)
    except OSError:
        pass
    shutil.copy2("8bit.orc", SHARE_DIR)
    shutil.copy2("microcsound_basic.orc", SHARE_DIR)
    shutil.copy2("ciconia.mc", SHARE_DIR)

    # output a final message:
    last_msg = ('''
If you didn't get any system error messages, your install is 
finished. Enjoy! 

Get started by reading the README file, and/or the HTML documentation via the 
'microcsound_docs.html' in a browser. Both are available in the 
%s directory. 

You can also see command line options by typing 'microcsound -h'. 

To try the Johannes Ciconia example, change to the 
%s directory, and type 'microcsound --orc 8bit.orc -r ciconia.mc' 
''')  % (DOC_DIR, SHARE_DIR)

    print last_msg

if __name__ == '__main__':
    install_script()
